# -*- coding: ISO-8859-1 -*-

##############################################################################
#
# Copyright (c) 2006 Alexis Roda. All Rights Reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
##############################################################################

"""

$Id: __init__.py 49 2006-09-30 10:47:00Z alex $
"""

__version__ = "$Revision: $"
# $Source: $

from ziptool import ZipTool
from ziptool import manage_addZipTool

import compressorregistry
import comprgzip
import comprbzip2
import comprnone

import archiverregistry
import archzip
import archtar

import permissions

def initialize(context) :
    context.registerClass(
        ZipTool,
        constructors=(manage_addZipTool, ),
        icon='images/tool.gif',
        permissions=(permissions.use_unzip_services, )
        )

    compressorregistry.initialize()
    compressorregistry.register(comprgzip.isgzip,
                                comprgzip.decompress)
    compressorregistry.register(comprbzip2.isbzip2,
                                comprbzip2.decompress)
    # cal que sigui l'ultim
    compressorregistry.register(comprnone.isuncompressed,
                                comprnone.decompress)

    archiverregistry.initialize()
    archiverregistry.register(archzip.isZip,
                              archzip.ZipArchive)
    archiverregistry.register(archtar.isTar,
                              archtar.TarArchive)


