# -*- coding: ISO-8859-1 -*-

##############################################################################
#
# Copyright (c) 2006 Alexis Roda. All Rights Reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
##############################################################################

"""

$Id: archtar.py 13 2006-05-21 22:21:14Z alex $
"""

__version__ = "$Revision: $"
# $Source: $

import tarfile

from archiveinterface import Member
from archiveinterface import Archive
from exceptions import BadArchiveError


class _TarMember(Member) :
    def read(self) :
        return self._archive.extractfile(self._member).read()

    def filename(self) :
        return self._member.name


class TarArchive(Archive) :
    def __init__(self, archname, archfile) :
        Archive.__init__(self, archname, archfile)
        try:
            self._arch = tarfile.TarFile(name='', mode='r', fileobj=archfile)
        except zipfile.error:
            raise BadArchiveError()

    def __iter__(self) :
        for membinfo in self._arch.getmembers() :
            if membinfo.isfile() :
                yield _TarMember(self._arch, membinfo)

    def close(self) :
        self._arch.close()
        self._arch = None


def isTar(file_) :
    file_.seek(257)
    return file_.read(5) == 'ustar'
