# -*- coding: ISO-8859-1 -*-

##############################################################################
#
# Copyright (c) 2006 Alexis Roda. All Rights Reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
##############################################################################

"""

$Id: archzip.py 13 2006-05-21 22:21:14Z alex $
"""

__version__ = "$Revision: $"
# $Source: $

import zipfile

from archiveinterface import Member
from archiveinterface import Archive
from exceptions import BadArchiveError


class _ZipMember(Member) :
    def read(self) :
        return self._archive.read(self.filename())

    def filename(self) :
        return self._member.filename

class ZipArchive(Archive) :
    def __init__(self, archname, archfile) :
        Archive.__init__(self, archname, archfile)
        try:
            self._zip = zipfile.ZipFile(archfile)
        except zipfile.error:
            raise BadArchiveError()

    def __iter__(self) :
        for zinfo in self._zip.infolist() :
            if not zinfo.filename.endswith('/') :
                yield _ZipMember(self._zip, zinfo)

    def close(self) :
        self._zip.close()
        self._zip = None

def isZip(file_) :
    file_.seek(0)
    return file_.read(4) == 'PK\x03\x04'
